/**
 * Autogenerated by Thrift Compiler (1.0.0-dev)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package jayeson.vodds.service.cms.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (1.0.0-dev)", date = "2022-4-26")
public class ThriftMplUpdate implements org.apache.thrift.TBase<ThriftMplUpdate, ThriftMplUpdate._Fields>, java.io.Serializable, Cloneable, Comparable<ThriftMplUpdate> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ThriftMplUpdate");

  private static final org.apache.thrift.protocol.TField CLOSE_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("closeId", org.apache.thrift.protocol.TType.I64, (short)1);
  private static final org.apache.thrift.protocol.TField MPL_VALUE_FIELD_DESC = new org.apache.thrift.protocol.TField("mplValue", org.apache.thrift.protocol.TType.DOUBLE, (short)2);
  private static final org.apache.thrift.protocol.TField USER_NAME_FIELD_DESC = new org.apache.thrift.protocol.TField("userName", org.apache.thrift.protocol.TType.STRING, (short)3);
  private static final org.apache.thrift.protocol.TField P_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("pId", org.apache.thrift.protocol.TType.I64, (short)4);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new ThriftMplUpdateStandardSchemeFactory());
    schemes.put(TupleScheme.class, new ThriftMplUpdateTupleSchemeFactory());
  }

  public long closeId; // required
  public double mplValue; // required
  public String userName; // required
  public long pId; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    CLOSE_ID((short)1, "closeId"),
    MPL_VALUE((short)2, "mplValue"),
    USER_NAME((short)3, "userName"),
    P_ID((short)4, "pId");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // CLOSE_ID
          return CLOSE_ID;
        case 2: // MPL_VALUE
          return MPL_VALUE;
        case 3: // USER_NAME
          return USER_NAME;
        case 4: // P_ID
          return P_ID;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __CLOSEID_ISSET_ID = 0;
  private static final int __MPLVALUE_ISSET_ID = 1;
  private static final int __PID_ISSET_ID = 2;
  private byte __isset_bitfield = 0;
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.CLOSE_ID, new org.apache.thrift.meta_data.FieldMetaData("closeId", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.MPL_VALUE, new org.apache.thrift.meta_data.FieldMetaData("mplValue", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE)));
    tmpMap.put(_Fields.USER_NAME, new org.apache.thrift.meta_data.FieldMetaData("userName", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.P_ID, new org.apache.thrift.meta_data.FieldMetaData("pId", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ThriftMplUpdate.class, metaDataMap);
  }

  public ThriftMplUpdate() {
  }

  public ThriftMplUpdate(
    long closeId,
    double mplValue,
    String userName,
    long pId)
  {
    this();
    this.closeId = closeId;
    setCloseIdIsSet(true);
    this.mplValue = mplValue;
    setMplValueIsSet(true);
    this.userName = userName;
    this.pId = pId;
    setPIdIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ThriftMplUpdate(ThriftMplUpdate other) {
    __isset_bitfield = other.__isset_bitfield;
    this.closeId = other.closeId;
    this.mplValue = other.mplValue;
    if (other.isSetUserName()) {
      this.userName = other.userName;
    }
    this.pId = other.pId;
  }

  public ThriftMplUpdate deepCopy() {
    return new ThriftMplUpdate(this);
  }

  @Override
  public void clear() {
    setCloseIdIsSet(false);
    this.closeId = 0;
    setMplValueIsSet(false);
    this.mplValue = 0.0;
    this.userName = null;
    setPIdIsSet(false);
    this.pId = 0;
  }

  public long getCloseId() {
    return this.closeId;
  }

  public ThriftMplUpdate setCloseId(long closeId) {
    this.closeId = closeId;
    setCloseIdIsSet(true);
    return this;
  }

  public void unsetCloseId() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __CLOSEID_ISSET_ID);
  }

  /** Returns true if field closeId is set (has been assigned a value) and false otherwise */
  public boolean isSetCloseId() {
    return EncodingUtils.testBit(__isset_bitfield, __CLOSEID_ISSET_ID);
  }

  public void setCloseIdIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __CLOSEID_ISSET_ID, value);
  }

  public double getMplValue() {
    return this.mplValue;
  }

  public ThriftMplUpdate setMplValue(double mplValue) {
    this.mplValue = mplValue;
    setMplValueIsSet(true);
    return this;
  }

  public void unsetMplValue() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __MPLVALUE_ISSET_ID);
  }

  /** Returns true if field mplValue is set (has been assigned a value) and false otherwise */
  public boolean isSetMplValue() {
    return EncodingUtils.testBit(__isset_bitfield, __MPLVALUE_ISSET_ID);
  }

  public void setMplValueIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __MPLVALUE_ISSET_ID, value);
  }

  public String getUserName() {
    return this.userName;
  }

  public ThriftMplUpdate setUserName(String userName) {
    this.userName = userName;
    return this;
  }

  public void unsetUserName() {
    this.userName = null;
  }

  /** Returns true if field userName is set (has been assigned a value) and false otherwise */
  public boolean isSetUserName() {
    return this.userName != null;
  }

  public void setUserNameIsSet(boolean value) {
    if (!value) {
      this.userName = null;
    }
  }

  public long getPId() {
    return this.pId;
  }

  public ThriftMplUpdate setPId(long pId) {
    this.pId = pId;
    setPIdIsSet(true);
    return this;
  }

  public void unsetPId() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __PID_ISSET_ID);
  }

  /** Returns true if field pId is set (has been assigned a value) and false otherwise */
  public boolean isSetPId() {
    return EncodingUtils.testBit(__isset_bitfield, __PID_ISSET_ID);
  }

  public void setPIdIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __PID_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case CLOSE_ID:
      if (value == null) {
        unsetCloseId();
      } else {
        setCloseId((Long)value);
      }
      break;

    case MPL_VALUE:
      if (value == null) {
        unsetMplValue();
      } else {
        setMplValue((Double)value);
      }
      break;

    case USER_NAME:
      if (value == null) {
        unsetUserName();
      } else {
        setUserName((String)value);
      }
      break;

    case P_ID:
      if (value == null) {
        unsetPId();
      } else {
        setPId((Long)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case CLOSE_ID:
      return Long.valueOf(getCloseId());

    case MPL_VALUE:
      return Double.valueOf(getMplValue());

    case USER_NAME:
      return getUserName();

    case P_ID:
      return Long.valueOf(getPId());

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case CLOSE_ID:
      return isSetCloseId();
    case MPL_VALUE:
      return isSetMplValue();
    case USER_NAME:
      return isSetUserName();
    case P_ID:
      return isSetPId();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof ThriftMplUpdate)
      return this.equals((ThriftMplUpdate)that);
    return false;
  }

  public boolean equals(ThriftMplUpdate that) {
    if (that == null)
      return false;

    boolean this_present_closeId = true;
    boolean that_present_closeId = true;
    if (this_present_closeId || that_present_closeId) {
      if (!(this_present_closeId && that_present_closeId))
        return false;
      if (this.closeId != that.closeId)
        return false;
    }

    boolean this_present_mplValue = true;
    boolean that_present_mplValue = true;
    if (this_present_mplValue || that_present_mplValue) {
      if (!(this_present_mplValue && that_present_mplValue))
        return false;
      if (this.mplValue != that.mplValue)
        return false;
    }

    boolean this_present_userName = true && this.isSetUserName();
    boolean that_present_userName = true && that.isSetUserName();
    if (this_present_userName || that_present_userName) {
      if (!(this_present_userName && that_present_userName))
        return false;
      if (!this.userName.equals(that.userName))
        return false;
    }

    boolean this_present_pId = true;
    boolean that_present_pId = true;
    if (this_present_pId || that_present_pId) {
      if (!(this_present_pId && that_present_pId))
        return false;
      if (this.pId != that.pId)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_closeId = true;
    list.add(present_closeId);
    if (present_closeId)
      list.add(closeId);

    boolean present_mplValue = true;
    list.add(present_mplValue);
    if (present_mplValue)
      list.add(mplValue);

    boolean present_userName = true && (isSetUserName());
    list.add(present_userName);
    if (present_userName)
      list.add(userName);

    boolean present_pId = true;
    list.add(present_pId);
    if (present_pId)
      list.add(pId);

    return list.hashCode();
  }

  @Override
  public int compareTo(ThriftMplUpdate other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetCloseId()).compareTo(other.isSetCloseId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetCloseId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.closeId, other.closeId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetMplValue()).compareTo(other.isSetMplValue());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMplValue()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.mplValue, other.mplValue);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetUserName()).compareTo(other.isSetUserName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetUserName()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.userName, other.userName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetPId()).compareTo(other.isSetPId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetPId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.pId, other.pId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("ThriftMplUpdate(");
    boolean first = true;

    sb.append("closeId:");
    sb.append(this.closeId);
    first = false;
    if (!first) sb.append(", ");
    sb.append("mplValue:");
    sb.append(this.mplValue);
    first = false;
    if (!first) sb.append(", ");
    sb.append("userName:");
    if (this.userName == null) {
      sb.append("null");
    } else {
      sb.append(this.userName);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("pId:");
    sb.append(this.pId);
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // alas, we cannot check 'closeId' because it's a primitive and you chose the non-beans generator.
    // alas, we cannot check 'mplValue' because it's a primitive and you chose the non-beans generator.
    if (userName == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'userName' was not present! Struct: " + toString());
    }
    // alas, we cannot check 'pId' because it's a primitive and you chose the non-beans generator.
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ThriftMplUpdateStandardSchemeFactory implements SchemeFactory {
    public ThriftMplUpdateStandardScheme getScheme() {
      return new ThriftMplUpdateStandardScheme();
    }
  }

  private static class ThriftMplUpdateStandardScheme extends StandardScheme<ThriftMplUpdate> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ThriftMplUpdate struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // CLOSE_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.closeId = iprot.readI64();
              struct.setCloseIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // MPL_VALUE
            if (schemeField.type == org.apache.thrift.protocol.TType.DOUBLE) {
              struct.mplValue = iprot.readDouble();
              struct.setMplValueIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // USER_NAME
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.userName = iprot.readString();
              struct.setUserNameIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 4: // P_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.pId = iprot.readI64();
              struct.setPIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      if (!struct.isSetCloseId()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'closeId' was not found in serialized data! Struct: " + toString());
      }
      if (!struct.isSetMplValue()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'mplValue' was not found in serialized data! Struct: " + toString());
      }
      if (!struct.isSetPId()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'pId' was not found in serialized data! Struct: " + toString());
      }
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ThriftMplUpdate struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldBegin(CLOSE_ID_FIELD_DESC);
      oprot.writeI64(struct.closeId);
      oprot.writeFieldEnd();
      oprot.writeFieldBegin(MPL_VALUE_FIELD_DESC);
      oprot.writeDouble(struct.mplValue);
      oprot.writeFieldEnd();
      if (struct.userName != null) {
        oprot.writeFieldBegin(USER_NAME_FIELD_DESC);
        oprot.writeString(struct.userName);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(P_ID_FIELD_DESC);
      oprot.writeI64(struct.pId);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ThriftMplUpdateTupleSchemeFactory implements SchemeFactory {
    public ThriftMplUpdateTupleScheme getScheme() {
      return new ThriftMplUpdateTupleScheme();
    }
  }

  private static class ThriftMplUpdateTupleScheme extends TupleScheme<ThriftMplUpdate> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ThriftMplUpdate struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      oprot.writeI64(struct.closeId);
      oprot.writeDouble(struct.mplValue);
      oprot.writeString(struct.userName);
      oprot.writeI64(struct.pId);
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ThriftMplUpdate struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      struct.closeId = iprot.readI64();
      struct.setCloseIdIsSet(true);
      struct.mplValue = iprot.readDouble();
      struct.setMplValueIsSet(true);
      struct.userName = iprot.readString();
      struct.setUserNameIsSet(true);
      struct.pId = iprot.readI64();
      struct.setPIdIsSet(true);
    }
  }

}

